﻿/* --------------------------------------------------------- */

// String$ = GetGadgetText(#Gadget)
function GetGadgetText(Gadget) {

  switch (GadgetType(Gadget)) {

    case PB_GadgetType_String:
      return $("#g_" + Gadget).val();
      break;

    case PB_GadgetType_Text:
      return $("#g_" + Gadget).text();
      break;

    case PB_GadgetType_Button:
      return $("#g_" + Gadget).button("option", "label");
      break;

    case PB_GadgetType_Web:
      return $("#g_" + Gadget).attr('src');
      break;

    case PB_GadgetType_CheckBox:
      return $("#lbl_" + Gadget).text();
      break;

    case PB_GadgetType_ComboBox:
        return $("#g_" + Gadget).val();
      break;

    default:

      if ($("#g_" + Gadget).is("input"))
        return $("#g_" + Gadget).val();

      else
        return $("#g_" + Gadget).text();

      break;

  }

}

/* --------------------------------------------------------- */

// SetGadgetText(#Gadget, Text$)
function SetGadgetText(Gadget, Text) {

  var selector = $("#g_" + Gadget);

  switch (GadgetType(Gadget)) {

    case PB_GadgetType_String:
      selector.val(Text);
      break;

    case PB_GadgetType_Text:
      selector.text(Text);
      break;

    case PB_GadgetType_Button:
      selector.button("option", "label", Text);
      break;

    case PB_GadgetType_Web:
      selector.attr('src', Text);
      break;

    case PB_GadgetType_CheckBox:
      $("#lbl_" + Gadget).text(Text);
      break;

    default:

      if ($("#g_" + Gadget).is("input"))
        $("#g_" + Gadget).val(Text);

      else
        $("#g_" + Gadget).text(Text);

      break;

  }

}

/* --------------------------------------------------------- */
/* --------------------------------------------------------- */

// Value = GetGadgetAttribute(#Gadget, Attribute)
function GetGadgetAttribute(Gadget, Attribute) {

  var selector = $("#g_" + Gadget);

  switch (GadgetType(Gadget)) {

    case PB_GadgetType_ButtonImageGadget:
      break;
    case PB_GadgetType_CalendarGadget:
      break;
    case PB_GadgetType_CanvasGadget:
      break;
    case PB_GadgetType_DateGadget:
      break;
    case PB_GadgetType_EditorGadget:
      break;
    case PB_GadgetType_ExplorerListGadget:
      break;
    case PB_GadgetType_ListIconGadget:
      break;
    case PB_GadgetType_MDIGadget:
      break;
    case PB_GadgetType_ProgressBarGadget:
      break;
    case PB_GadgetType_ScrollAreaGadget:
      break;
    case PB_GadgetType_ScrollBarGadget:
      break;
    case PB_GadgetType_SpinGadget:
      break;
    case PB_GadgetType_SplitterGadget:
      break;
    case PB_GadgetType_TrackBarGadget:
      break;
    case PB_GadgetType_WebGadget:
      break;
    default:
      console.log('GetGadgetAttribute() is not supported for this gadget-type.');
      break;

  }


}

/* --------------------------------------------------------- */

// SetGadgetAttribute(#Gadget, Attribute, Value)
function SetGadgetAttribute(Gadget, Attribute, Value) {

  var selector = $("#g_" + Gadget);

  switch (GadgetType(Gadget)) {

    case PB_GadgetType_ButtonImage:
      break;
    case PB_GadgetType_Calendar:
      break;
    case PB_GadgetType_Canvas:
      break;
    case PB_GadgetType_Date:
      break;
    case PB_GadgetType_Editor:
      break;
    case PB_GadgetType_ExplorerList:
      break;
    case PB_GadgetType_ListIcon:
      break;
    case PB_GadgetType_MDI:
      break;
    case PB_GadgetType_ProgressBar:
      break;
    case PB_GadgetType_ScrollArea:
      break;
    case PB_GadgetType_ScrollBar:
      break;
    case PB_GadgetType_Spin:
      break;
    case PB_GadgetType_Splitter:
      break;
    case PB_GadgetType_TrackBar:
      break;
    case PB_GadgetType_Web:
      break;
    default:
      console.log('SetGadgetAttribute() is not supported for this gadget-type.');
      break;

  }

}

/* --------------------------------------------------------- */
/* --------------------------------------------------------- */

// Color = GetGadgetColor(#Gadget, ColorType)
function GetGadgetColor(Gadget, ColorType) {

  if ($("#g_" + Gadget) == null) { return; }

  /*
  #PB_Gadget_FrontColor     : Gadget text
  #PB_Gadget_BackColor      : Gadget background
  #PB_Gadget_LineColor      : Color for gridlines
  #PB_Gadget_TitleFrontColor: Text color in the title        (for CalendarGadget())
  #PB_Gadget_TitleBackColor : Background color in the title  (for CalendarGadget())
  #PB_Gadget_GrayTextColor  : Color for grayed out text      (for CalendarGadget())
  */

  // todo rgb(243, 191, 189)

  switch (ColorType) {

    case PB_Gadget_FrontColor:
      return $("#g_" + Gadget).css("color");
      break;
    case PB_Gadget_BackColor:
      return $("#g_" + Gadget).css("background-color");
      break;
    case PB_Gadget_LineColor:
      break;
    case PB_Gadget_TitleFrontColor:
      break;
    case PB_Gadget_TitleBackColor:
      break;
    case PB_Gadget_GrayTextColor:
      break;

  }

}

/* --------------------------------------------------------- */

// SetGadgetColor(#Gadget, ColorType, Color)
function SetGadgetColor(Gadget, ColorType, Color) {

  if ($("#g_" + Gadget) == null) { return; }

  /*
  #PB_Gadget_FrontColor     : Gadget text
  #PB_Gadget_BackColor      : Gadget background
  #PB_Gadget_LineColor      : Color for gridlines
  #PB_Gadget_TitleFrontColor: Text color in the title        (for CalendarGadget())
  #PB_Gadget_TitleBackColor : Background color in the title  (for CalendarGadget())
  #PB_Gadget_GrayTextColor  : Color for grayed out text      (for CalendarGadget())
  */

  // todo rgb(243, 191, 189)

  switch (ColorType) {

    case PB_Gadget_FrontColor:
      $("#g_" + Gadget).css({ "color": Color });
      break;
    case PB_Gadget_BackColor:
      $("#g_" + Gadget).css({ "background-color": Color });
      break;
    case PB_Gadget_LineColor:
      break;
    case PB_Gadget_TitleFrontColor:
      break;
    case PB_Gadget_TitleBackColor:
      break;
    case PB_Gadget_GrayTextColor:
      break;

  }

}

/* --------------------------------------------------------- */
/* --------------------------------------------------------- */

// Result = GetGadgetData(#Gadget)
function GetGadgetData(Gadget) {

  if ($("#g_" + Gadget) == null) { return; }

  return $("#g_" + Gadget).data("data");

}

/* --------------------------------------------------------- */

// SetGadgetData(#Gadget, Value)
function SetGadgetData(Gadget, Value) {

  if ($("#g_" + Gadget) == null) { return; }

  $("#g_" + Gadget).data("data", Value);

}

/* --------------------------------------------------------- */
/* --------------------------------------------------------- */

function GetGadgetItemAttribute() {
  console.log('GetGadgetItemAttribute(): Not implemented (yet)');
}

/* --------------------------------------------------------- */

function SetGadgetItemAttribute() {
  console.log('SetGadgetItemAttribute(): Not implemented (yet)');
}

/* --------------------------------------------------------- */
/* --------------------------------------------------------- */

function GetGadgetItemColor() {
  console.log('GetGadgetItemColor(): Not implemented (yet)');
}

/* --------------------------------------------------------- */

function SetGadgetItemColor() {
  console.log('SetGadgetItemColor(): Not implemented (yet)');
}

/* --------------------------------------------------------- */
/* --------------------------------------------------------- */

function GetGadgetItemData() {
  console.log('GetGadgetItemData(): Not implemented (yet)');
}

/* --------------------------------------------------------- */

function SetGadgetItemData() {
  console.log('SetGadgetItemData(): Not implemented (yet)');
}

/* --------------------------------------------------------- */
/* --------------------------------------------------------- */

// Result = GetGadgetState(#Gadget)
function GetGadgetState(Gadget) {

  var selector = $("#g_" + Gadget);

  switch (GadgetType(Gadget)) {
    case PB_GadgetType_ButtonImage:
      break;
    case PB_GadgetType_Button:
      break;
    case PB_GadgetType_Calendar:
      break;
    case PB_GadgetType_CheckBox:
      return $("#cb_" + Gadget).prop("checked");
      break;
    case PB_GadgetType_ComboBox:
      break;
    case PB_GadgetType_Date:
      break;
    case PB_GadgetType_ExplorerList:
      break;
    case PB_GadgetType_ExplorerTree:
      break;
    case PB_GadgetType_Image:
      break;
    case PB_GadgetType_IPAddress:
      break;
    case PB_GadgetType_ListIcon:
      break;
    case PB_GadgetType_ListView:
      return $("#g_" + Gadget + " option").index($("#g_" + Gadget + " option").filter(":selected"));
      break;
    case PB_GadgetType_MDI:
      break;
    case PB_GadgetType_Option:
      break;
    case PB_GadgetType_Panel:
      break;
    case PB_GadgetType_ProgressBar:
      return $("#g_" + Gadget).progressbar("option", "value");
      break;
    case PB_GadgetType_ScrollBar:
      break;
    case PB_GadgetType_Shortcut:
      break;
    case PB_GadgetType_Spin:
      break;
    case PB_GadgetType_Splitter:
      break;
    case PB_GadgetType_TrackBar:
      return $("#g_" + Gadget).slider("value");
      break;
    case PB_GadgetType_Tree:
      break;
    default:
      console.log('SetGadgetAttribute() is not supported for this gadget-type.');

  }

}

/* --------------------------------------------------------- */

// SetGadgetState(#Gadget, State)
function SetGadgetState(Gadget, State) {

  var selector = $("#g_" + Gadget);

  switch (GadgetType(Gadget)) {
    case PB_GadgetType_ButtonImage:
      break;
    case PB_GadgetType_Button:
      break;
    case PB_GadgetType_Calendar:
      break;
    case PB_GadgetType_CheckBox:

      if (CheckFlag(State, PB_Checkbox_Checked)) {
        $("#cb_" + Gadget).prop("checked", true); 
       }
      else if (CheckFlag(State, PB_Checkbox_Unchecked)) {
        $("#cb_" + Gadget).prop("checked", false); 
       }
      else if (CheckFlag(State, PB_Checkbox_Inbetween)) {
        console.log('PB_CheckBox_Inbetween is not supported.'); 
       }

      break;

    case PB_GadgetType_ComboBox:
      break;
    case PB_GadgetType_Date:
      break;
    case PB_GadgetType_ExplorerList:
      break;
    case PB_GadgetType_ExplorerTree:
      break;
    case PB_GadgetType_Image:
      break;
    case PB_GadgetType_IPAddress:
      break;
    case PB_GadgetType_ListIcon:
      break;
    case PB_GadgetType_ListView:
      break;
    case PB_GadgetType_MDI:
      break;
    case PB_GadgetType_Option:
      break;
    case PB_GadgetType_Panel:
      break;
    case PB_GadgetType_ProgressBar:
      $("#g_" + Gadget).progressbar("option", "value", parseInt(State));
      break;
    case PB_GadgetType_ScrollBar:
      break;
    case PB_GadgetType_Shortcut:
      break;
    case PB_GadgetType_Spin:
      break;
    case PB_GadgetType_Splitter:
      break;
    case PB_GadgetType_TrackBar:
      break;
    case PB_GadgetType_Tree:
      break;
    default:
      console.log('SetGadgetState() is not supported for this gadget-type.');

  }

}

/* --------------------------------------------------------- */
/* --------------------------------------------------------- */

// Result = GetGadgetItemState(#Gadget, Item)
function GetGadgetItemState(Gadget, Item) {

  var selector = $("#g_" + Gadget);

  switch (GadgetType(Gadget)) {

    case PB_GadgetType_Calendar:
      break;
    case PB_GadgetType_Explorer:
      break;
    case PB_GadgetType_ListView:
      break;
    case PB_GadgetType_ListIcon:
      if ($("#g_" + Gadget + " > tbody  > tr:eq(" + Item + ")").data("selected")) {
        return true;
      }
      else {
        return false;
      }
      break;
    case PB_GadgetType_Tree:
      break;
    default:
      console.log('GetGadgetItemState() is not supported for this gadget-type.');
      break;

  }

}

/* --------------------------------------------------------- */

// SetGadgetItemState(#Gadget, Item, State)
function SetGadgetItemState(Gadget, Item, State) {

  var selector = $("#g_" + Gadget);

  switch (GadgetType(Gadget)) {

    case PB_GadgetType_Calendar:
      break;
    case PB_GadgetType_Explorer:
      break;
    case PB_GadgetType_ListView:
      break;
    case PB_GadgetType_ListIcon:

      /*  
      - ListIconGadget(): Combination of the following values: 
      #PB_ListIcon_Selected : The item should be selected.
      #PB_ListIcon_Checked  : The item should have its checkbox checked (#PB_ListIcon_CheckBoxes flag).
      #PB_ListIcon_Inbetween: The item should have its checkbox in the in between state (#PB_ListIcon_ThreeState flag).
      */

      if (CheckFlag(State, PB_ListIcon_Selected)) {

        $("#g_" + Gadget + " > tbody  > tr").each(function () {

          if ($(this).data("selected") == true) {
            $(this).data("selected", false);
            $(this).css({ "background-color": "white", "color": "black" });
          }

        });

        $("#g_" + Gadget + " > tbody  > tr:eq(" + Item + ")").data("selected", true);
        $("#g_" + Gadget + " > tbody  > tr:eq(" + Item + ")").css({ "background-color": "blue", "color": "white" });

      }

      break;
    case PB_GadgetType_Tree:
      break;
    default:
      console.log('GetGadgetItemState() is not supported for this gadget-type.');
      break;

  }

}

/* --------------------------------------------------------- */
/* --------------------------------------------------------- */

// Result$ = GetGadgetItemText(#Gadget, Item [, Column])
function GetGadgetItemText(Gadget, Item, Column) {

  if ("#g_" + Gadget == null) { return ""; }

  if (Column == null) { Column = 0; }

  if ($("#g_" + Gadget).is("table")) {
    if (Item == -1) {
      // If Item = -1, the header text of the given column is changed.
      return $("#g_" + Gadget + " thead tr:first td:eq(" + Column + ")").html();
    }
    else {
      return $("#g_" + Gadget + " tbody tr:eq(" + Item + ") td:eq(" + Column + ")").html();
    }
  }
  else {
    console.log("%s: %o", "GetGadgetItemText (this type of gadget is not supported yet)", Gadget);
  }

}

/* --------------------------------------------------------- */

// SetGadgetItemText(#Gadget, Item, Text$ [, Column])
function SetGadgetItemText(Gadget, Item, Text, Column) {

  var selector = $("#g_" + Gadget);

  switch (GadgetType(Gadget)) {

    case PB_GadgetType_Web:

      if (Item = PB_Web_HtmlCode) {

        var iframe = document.getElementById("g_" + Gadget);
        if (iframe.contentWindow) {
          iframe = iframe.contentWindow;
        } else {
          if (iframe.contentDocument && iframe.contentDocument.document) {
            iframe = iframe.contentDocument.document;
          } else {
            iframe = iframe.contentDocument;
          }
        }

        iframe.document.open();
        iframe.document.write(Text);
        iframe.document.close();

      }

      break;

    default:

      // The column to use for gadgets that support multiple columns. The first column has index 0. The default is column 0.   

      if (Column == null) { Column = 0; }

      if ($("#g_" + Gadget).is("table")) {
        if (Item == -1) {
          // If Item = -1, the header text of the given column is changed.
          $("#g_" + Gadget + " thead tr:first td:eq(" + Column + ")").html(Text);
        }
        else {
          $("#g_" + Gadget + " tbody tr:eq(" + Item + ") td:eq(" + Column + ")").html(Text);
        }
      }
      else {
      }

      break;

  }


}

/* --------------------------------------------------------- */
/* --------------------------------------------------------- */

// SetGadgetFont(#Gadget, FontID)
function SetGadgetFont(Gadget, FontID) {

  if ($("#g_" + Gadget) == null) { return; }
  if ($("#f_" + FontID) == null) { return; }

  $("#g_" + Gadget).css({ 'font-size': $("#f_" + FontID).css("font-size") });
  $("#g_" + Gadget).css({ 'font-family': $("#f_" + FontID).css("font-family") });
  $("#g_" + Gadget).css({ 'font-weight': $("#f_" + FontID).css("font-weight") });
  $("#g_" + Gadget).css({ 'font-style': $("#f_" + FontID).css("font-style") });

}

/* --------------------------------------------------------- */
/* --------------------------------------------------------- */

function SetGadgetItemImage() {
  console.log('SetGadgetItemImage(): Not implemented (yet)');
}

/* --------------------------------------------------------- */
/* --------------------------------------------------------- */